/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of FileList.xs. Do not edit this file, edit FileList.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "FileList.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "string.h"
#include "flist.h"

typedef struct file_list *File__RsyncP__FileList;

/*
 * Pick an integer setting out of the hash ref opts.  If the argument
 * isn't a hash, or doesn't contain param, then returns def.
 */
static int getHashInt(SV *opts, char *param, int def)
{
    SV **vp;

    if ( !opts || !SvROK(opts)
               || SvTYPE(SvRV(opts)) != SVt_PVHV
               || !(vp = hv_fetch((HV*)SvRV(opts), param, strlen(param), 0))
               || !*vp ) {
        return def;
    }
    return SvIV(*vp);
}

/*
 * Pick an unsigned integer setting out of the hash ref opts.  If the
 * argument isn't a hash, or doesn't contain param, then returns def.
 */
static unsigned int getHashUInt(SV *opts, char *param, int def)
{
    SV **vp;

    if ( !opts || !SvROK(opts)
               || SvTYPE(SvRV(opts)) != SVt_PVHV
               || !(vp = hv_fetch((HV*)SvRV(opts), param, strlen(param), 0))
               || !*vp ) {
        return def;
    }
    return SvUV(*vp);
}

/*
 * Pick a string setting out of the hash ref opts.  If the argument
 * isn't a hash, or doesn't contain param, then returns def.
 */
static int getHashString(SV *opts, char *param, char *def,
                          char *result, int maxLen)
{
    SV **vp;
    char *str;
    int len;

    if ( !opts || !SvROK(opts)
               || SvTYPE(SvRV(opts)) != SVt_PVHV
               || !(vp = hv_fetch((HV*)SvRV(opts), param, strlen(param), 0))
               || !*vp ) {
        if ( !def )
            return -1;
        strcpy(result, def);
        return 0;
    } else {
        str = (char*)SvPV(*vp, len);
        if ( len >= maxLen ) {
            return -1;
        }
        memcpy(result, str, len);
        result[len] = '\0';
    }
    return 0;
}

/*
 * Pick a double setting out of the hash ref opts.  If the argument
 * isn't a hash, or doesn't contain param, then returns def.
 */
static double getHashDouble(SV *opts, char *param, double def)
{
    SV **vp;

    if ( !opts || !SvROK(opts)
               || SvTYPE(SvRV(opts)) != SVt_PVHV
               || !(vp = hv_fetch((HV*)SvRV(opts), param, strlen(param), 0))
               || !*vp ) {
        return def;
    }
    return SvNV(*vp);
}


#line 101 "FileList.c"
XS(XS_File__RsyncP__FileList_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_new)
{
    dXSARGS;
    if (items < 0 || items > 2)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::new(packname = \"File::RsyncP::FileList\", opts = NULL)");
    {
	char *	packname;
	SV*	opts;
	File__RsyncP__FileList	RETVAL;

	if (items < 1)
	    packname = "File::RsyncP::FileList";
	else {
	    packname = (char *)SvPV_nolen(ST(0));
	}

	if (items < 2)
	    opts = NULL;
	else {
	    opts = ST(1);
	}
#line 100 "FileList.xs"
    {
        RETVAL = flist_new();
        RETVAL->preserve_links   = getHashInt(opts, "preserve_links", 1);
        RETVAL->preserve_uid     = getHashInt(opts, "preserve_uid",   1);
        RETVAL->preserve_gid     = getHashInt(opts, "preserve_gid",   1);
        RETVAL->preserve_devices = getHashInt(opts, "preserve_devices", 0);
        RETVAL->always_checksum  = getHashInt(opts, "always_checksum", 0);
        RETVAL->preserve_hard_links = getHashInt(opts, "preserve_hard_links",
                                                       0);
        RETVAL->remote_version   = getHashInt(opts, "remote_version", 26);
    }
#line 136 "FileList.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "File::RsyncP::FileList", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_File__RsyncP__FileList_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::DESTROY(flist)");
    {
	File__RsyncP__FileList	flist;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not a reference");
#line 118 "FileList.xs"
    {
        flist_free(flist);
    }
#line 162 "FileList.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_File__RsyncP__FileList_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_count)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::count(flist)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 126 "FileList.xs"
    {
        RETVAL = flist->count;
    }
#line 188 "FileList.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_File__RsyncP__FileList_fatalError); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_fatalError)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::fatalError(flist)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 136 "FileList.xs"
    {
        RETVAL = flist->fatalError;
    }
#line 215 "FileList.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_File__RsyncP__FileList_decodeDone); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_decodeDone)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::decodeDone(flist)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 146 "FileList.xs"
    {
        RETVAL = flist->decodeDone;
    }
#line 242 "FileList.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_File__RsyncP__FileList_decode); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_decode)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::decode(flist, bytesSV)");
    {
#line 155 "FileList.xs"
	STRLEN nBytes;
#line 257 "FileList.c"
	File__RsyncP__FileList	flist;
	SV *	bytesSV = ST(1);
	unsigned char *	bytes = (unsigned char *)SvPV(bytesSV, nBytes);
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 161 "FileList.xs"
    {
        RETVAL = flistDecodeBytes(flist, bytes, nBytes);
    }
#line 274 "FileList.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_File__RsyncP__FileList_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_get)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::get(flist, index)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	index = (unsigned int)SvUV(ST(1));
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 173 "FileList.xs"
    {
        HV *rh;
        struct file_struct *file;

        if ( index >= flist->count ) {
            XSRETURN_UNDEF; 
        }
        file = flist->files[index];
        rh = (HV *)sv_2mortal((SV *)newHV());
        if ( file->basename )
            hv_store(rh, "basename", 8, newSVpv(file->basename, 0), 0);
        if ( file->dirname )
            hv_store(rh, "dirname",  7, newSVpv(file->dirname, 0), 0);
        if ( file->link )
            hv_store(rh, "link",     4, newSVpv(file->link, 0), 0);
        if ( file->sum )
            hv_store(rh, "sum",      3, newSVpv(file->sum, 0), 0);
        hv_store(rh, "name",    4, newSVpv(f_name(file), 0), 0);
        hv_store(rh, "uid",     3, newSVnv((double)((unsigned)file->uid)), 0);
        hv_store(rh, "gid",     3, newSVnv((double)((unsigned)file->gid)), 0);
        hv_store(rh, "mode",    4, newSVnv((double)((unsigned)file->mode)), 0);
        hv_store(rh, "mtime",   5,
			    newSVnv((double)((unsigned)file->modtime)), 0);
        hv_store(rh, "size",    4, newSVnv(file->length), 0);
        hv_store(rh, "dev",     3, newSVnv(file->dev), 0);
        hv_store(rh, "inode",   5, newSVnv(file->inode), 0);
        hv_store(rh, "rdev",    4, newSVnv((double)file->rdev), 0);
        RETVAL = newRV((SV*)rh);
    }
#line 327 "FileList.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_File__RsyncP__FileList_flagGet); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_flagGet)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::flagGet(flist, index)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	index = (unsigned int)SvUV(ST(1));
	unsigned int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 211 "FileList.xs"
    {
        if ( index >= flist->count ) {
            XSRETURN_UNDEF; 
        }
        RETVAL = flist->files[index]->flags;
    }
#line 359 "FileList.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_File__RsyncP__FileList_flagSet); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_flagSet)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::flagSet(flist, index, value)");
    {
	File__RsyncP__FileList	flist;
	unsigned int	index = (unsigned int)SvUV(ST(1));
	unsigned int	value = (unsigned int)SvUV(ST(2));

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 227 "FileList.xs"
    {
        if ( index < flist->count ) {
	    flist->files[index]->flags = value;
        }
    }
#line 388 "FileList.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_File__RsyncP__FileList_clean); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_clean)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::clean(flist)");
    {
	File__RsyncP__FileList	flist;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 238 "FileList.xs"
    {
        clean_flist(flist, 0);
    }
#line 412 "FileList.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_File__RsyncP__FileList_encode); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_encode)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::encode(flist, data)");
    {
	File__RsyncP__FileList	flist;
	SV*	data = ST(1);

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 248 "FileList.xs"
    {
        struct file_struct file, *fileCopy;
        char name[MAXPATHLEN];
        char linkbuf[MAXPATHLEN];
        char *p;
        int gotLink = 0;

        memset(&file, 0, sizeof(file));
        if ( getHashString(data, "name", NULL, name, MAXPATHLEN-1) ) {
            printf("flist encode: empty or too long name\n");
            return;
        }
        clean_fname(name);
        if ( !getHashString(data, "link", NULL, linkbuf, MAXPATHLEN-1) ) {
            gotLink = 1;
        }
	if ((p = strrchr(name, '/'))) {
            *p = 0;
            if ( flist->lastdir && strcmp(name, flist->lastdir) == 0 ) {
                file.dirname = flist->lastdir;
                file.dirnameAlloc = 0;
            } else {
                file.dirname = strdup(name);
                flist->lastdir = file.dirname;
                file.dirnameAlloc = 1;
            }
            file.basename = strdup(p + 1);
            *p = '/';
	} else {
            file.dirname = NULL;
            file.basename = strdup(name);
	}

	file.modtime = getHashUInt(data, "mtime", 0);
	file.length  = getHashDouble(data, "size", 0.0);
	file.mode    = getHashUInt(data, "mode", 0);
	file.uid     = getHashUInt(data, "uid", 0);
	file.gid     = getHashUInt(data, "gid", 0);
	file.dev     = getHashDouble(data, "dev", 0.0);
	file.inode   = getHashDouble(data, "inode", 0.0);
	file.rdev    = getHashUInt(data, "rdev", 0);
	if ( gotLink ) {
            file.link = strdup(linkbuf);
	}
	if ( flist->always_checksum ) {
            char sum[MAXPATHLEN];
            if ( !getHashString(data, "sum", NULL, sum, MAXPATHLEN-1) ) {
                printf("flist encode: missing sum with always_checksum\n");
                return;
            }
            file.sum = (char *) malloc(MD4_SUM_LENGTH);
            memcpy(file.sum, sum, MD4_SUM_LENGTH);
	}
        flist_expand(flist);
        if ( strcmp(file.basename, "") ) {
            fileCopy = (struct file_struct*)malloc(sizeof(*fileCopy));
            *fileCopy = file;
            flist->files[flist->count++] = fileCopy;
            send_file_entry(flist, fileCopy);
        }
    }
#line 495 "FileList.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_File__RsyncP__FileList_encodeData); /* prototype to pass -Wmissing-prototypes */
XS(XS_File__RsyncP__FileList_encodeData)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: File::RsyncP::FileList::encodeData(flist)");
    {
	File__RsyncP__FileList	flist;
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "File::RsyncP::FileList")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    flist = INT2PTR(File__RsyncP__FileList,tmp);
	}
	else
	    Perl_croak(aTHX_ "flist is not of type File::RsyncP::FileList");
#line 315 "FileList.xs"
    {
        if ( !flist->outBuf || flist->outPosn == 0 ) {
            ST(0) = sv_2mortal(newSVpv("", 0));
        } else {
            ST(0) = sv_2mortal(newSVpv((char*)flist->outBuf, flist->outPosn));
            flist->outPosn = 0;
        }
    }
#line 525 "FileList.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_File__RsyncP__FileList); /* prototype to pass -Wmissing-prototypes */
XS(boot_File__RsyncP__FileList)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXS("File::RsyncP::FileList::new", XS_File__RsyncP__FileList_new, file);
        newXS("File::RsyncP::FileList::DESTROY", XS_File__RsyncP__FileList_DESTROY, file);
        newXS("File::RsyncP::FileList::count", XS_File__RsyncP__FileList_count, file);
        newXS("File::RsyncP::FileList::fatalError", XS_File__RsyncP__FileList_fatalError, file);
        newXS("File::RsyncP::FileList::decodeDone", XS_File__RsyncP__FileList_decodeDone, file);
        newXS("File::RsyncP::FileList::decode", XS_File__RsyncP__FileList_decode, file);
        newXS("File::RsyncP::FileList::get", XS_File__RsyncP__FileList_get, file);
        newXS("File::RsyncP::FileList::flagGet", XS_File__RsyncP__FileList_flagGet, file);
        newXS("File::RsyncP::FileList::flagSet", XS_File__RsyncP__FileList_flagSet, file);
        newXS("File::RsyncP::FileList::clean", XS_File__RsyncP__FileList_clean, file);
        newXS("File::RsyncP::FileList::encode", XS_File__RsyncP__FileList_encode, file);
        newXS("File::RsyncP::FileList::encodeData", XS_File__RsyncP__FileList_encodeData, file);
    XSRETURN_YES;
}

